import time

from .thirdparty_packages import requests
try:
    from config import ThirdServicesConfig
    DNSLOG_SERVER = ThirdServicesConfig.DNSLOG_SERVER
except ImportError:
    DNSLOG_SERVER = "http://127.0.0.1:8011"


class GTLog(object):
    gtlog_addr = DNSLOG_SERVER

    def __init__(self):
        self.domain = ""
        self.unique_id = ""

    def get_random_domain(self, delay=5):
        loop = 0
        while loop < 3:
            time.sleep(delay)
            try:
                rs = requests.post('{}/gtlog/api/get_domain'.format(self.gtlog_addr))
            except:
                pass
            else:
                if rs.status_code == 200:
                    domain = self.domain = rs.json()['domain']
                    self.unique_id = rs.json()['unique_id']
                    return domain
            finally:
                loop = loop + 1
        return False

    def verify_dnslog(self, delay=5):
        loop = 0
        while loop < 5:
            time.sleep(delay)
            try:
                rs = requests.post('{}/gtlog/api/{}/dnslog'.format(self.gtlog_addr, self.unique_id))
            except:
                pass
            else:
                if rs.status_code == 200 and rs.json().get("count", 0) > 0:
                    return True
            finally:
                loop = loop + 1
        return False

    def verify_weblog(self, delay=5):
        loop = 0
        while loop < 5:
            time.sleep(delay)
            try:
                rs = requests.post('{}/gtlog/api/{}/weblog'.format(self.gtlog_addr, self.unique_id))
            except:
                pass
            else:
                if rs.status_code == 200 and rs.json().get("count", 0) > 0:
                    return True
            finally:
                loop = loop + 1
        return False
